Index: /NEMO/trunk/cfgs/SHARED/field_def_nemo-pisces.xml
===================================================================
--- /NEMO/trunk/cfgs/SHARED/field_def_nemo-pisces.xml	(revision 10415)
+++ /NEMO/trunk/cfgs/SHARED/field_def_nemo-pisces.xml	(revision 10416)
@@ -105,6 +105,4 @@
        <field id="LGW"         long_name="Weak ligands concentration"                unit="mmol/m3" />
        <field id="LGW_e3t"     long_name="LGW * e3t"                                 unit="mmol/m2"  > LGW * e3t </field >
-       <field id="LFe"         long_name="Lithogenic iron concentration"             unit="mmol/m3" />
-       <field id="LFe_e3t"     long_name="LFe * e3t"                                 unit="mmol/m2"  > LFe * e3t </field >
 
        <!-- PISCES light : variables available with ln_p2z  -->
Index: /NEMO/trunk/cfgs/SHARED/namelist_pisces_ref
===================================================================
--- /NEMO/trunk/cfgs/SHARED/namelist_pisces_ref	(revision 10415)
+++ /NEMO/trunk/cfgs/SHARED/namelist_pisces_ref	(revision 10416)
@@ -52,5 +52,4 @@
    wsbio2scale =  5000.    ! Big particles length scale of sinking
 !                         !  ln_ligand enabled
-   wfep       =  0.2      ! FeP sinking speed 
    ldocp      =  1.E-4    ! Phyto ligand production per unit doc 
    ldocz      =  1.E-4    ! Zoo ligand production per unit doc 
@@ -221,5 +220,5 @@
    sigma2     =  0.6      ! Fraction of mesozoo excretion as DOM
    unass2     =  0.3      ! non assimilated fraction of P by mesozoo
-   grazflux   =  2.e3     ! flux-feeding rate
+   grazflux   =  3.e3     ! flux-feeding rate
 /
 !-----------------------------------------------------------------------
@@ -380,7 +379,4 @@
    hratio      =  1.e+7    ! Fe to 3He ratio assumed for vent iron supply 
 !                          ! ln_ligand
-   fep_rats    =  1.       ! Fep/Fer ratio from sed sources 
-   fep_rath    =  1.       ! Fep/Fer ratio from sed hydro sources 
-   rdustfep    =  0.0      ! Fraction of dust that is FeP
    lgw_rath    =  0.5      ! Weak ligand ratio from sed hydro sources 
 /
@@ -388,5 +384,4 @@
 &nampislig     !   Namelist parameters for ligands, nampislig
 !-----------------------------------------------------------------------
-   rfep        =  0.001    ! Dissolution rate of FeP
    rlgw        =  100.     ! Lifetime (years) of weak ligands
    rlig        =  1.E-4    ! Remin ligand production per unit C
Index: /NEMO/trunk/src/TOP/PISCES/P4Z/p4zfechem.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P4Z/p4zfechem.F90	(revision 10415)
+++ /NEMO/trunk/src/TOP/PISCES/P4Z/p4zfechem.F90	(revision 10416)
@@ -195,5 +195,4 @@
                   zaggliga = zlam1a * xstep * zligco
                   zaggligb = zlam1b * xstep * zligco
-                  tra(ji,jj,jk,jpfep) = tra(ji,jj,jk,jpfep) + precip(ji,jj,jk)
                   tra(ji,jj,jk,jplgw) = tra(ji,jj,jk,jplgw) - zaggliga - zaggligb
                   zlcoll3d(ji,jj,jk)  = zaggliga + zaggligb
Index: /NEMO/trunk/src/TOP/PISCES/P4Z/p4zligand.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P4Z/p4zligand.F90	(revision 10415)
+++ /NEMO/trunk/src/TOP/PISCES/P4Z/p4zligand.F90	(revision 10416)
@@ -25,5 +25,4 @@
    REAL(wp), PUBLIC ::  rlig     !: Remin ligand production
    REAL(wp), PUBLIC ::  prlgw    !: Photochemical of weak ligand
-   REAL(wp), PUBLIC ::  rfep     !: Dissolution rate of FeP
 
    !!----------------------------------------------------------------------
@@ -43,5 +42,5 @@
       !
       INTEGER  ::   ji, jj, jk
-      REAL(wp) ::   zlgwp, zlgwpr, zlgwr, zlablgw, zrfepa, zfepr
+      REAL(wp) ::   zlgwp, zlgwpr, zlgwr, zlablgw
       REAL(wp), DIMENSION(jpi,jpj,jpk) :: zligrem, zligpr, zrligprod
       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   zw3d
@@ -71,16 +70,4 @@
                zligpr(ji,jj,jk)    = zlgwpr
                zrligprod(ji,jj,jk) = zlgwp
-               !
-               ! ----------------------------------------------------------
-               ! Dissolution of nanoparticle Fe
-               ! ----------------------------------------------------------
-               ! dissolution rate is maximal in the presence of light and 
-               ! lower in the aphotici zone
-               ! ! 25 Wm-2 constant
-               zrfepa = rfep * ( 1. - EXP( -1. * etot(ji,jj,jk) / 25. ) ) * (1.- fr_i(ji,jj))
-               zrfepa = MAX( (zrfepa / 10.0), zrfepa ) ! min of 10 days lifetime
-               zfepr  = rfep * xstep * trb(ji,jj,jk,jpfep)
-               tra(ji,jj,jk,jpfep) = tra(ji,jj,jk,jpfep) - zfepr
-               tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) + zfepr
                !
             END DO
@@ -130,5 +117,5 @@
       INTEGER ::   ios   ! Local integer 
       !
-      NAMELIST/nampislig/ rlgw, prlgw, rlgs, rfep, rlig
+      NAMELIST/nampislig/ rlgw, prlgw, rlgs, rlig
       !!----------------------------------------------------------------------
       !
@@ -148,5 +135,4 @@
       IF(lwp) THEN                         ! control print
          WRITE(numout,*) '   Namelist : nampislig'
-         WRITE(numout,*) '      Dissolution rate of FeP                      rfep  =', rfep
          WRITE(numout,*) '      Lifetime (years) of weak ligands             rlgw  =', rlgw
          WRITE(numout,*) '      Remin ligand production per unit C           rlig  =', rlig
Index: /NEMO/trunk/src/TOP/PISCES/P4Z/p4zsbc.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P4Z/p4zsbc.F90	(revision 10415)
+++ /NEMO/trunk/src/TOP/PISCES/P4Z/p4zsbc.F90	(revision 10416)
@@ -31,5 +31,4 @@
    REAL(wp), PUBLIC ::   dustsolub    !: Solubility of the dust
    REAL(wp), PUBLIC ::   mfrac        !: Mineral Content of the dust
-   REAL(wp), PUBLIC ::   rdustfep     !: Fraction of dust that is dissolvable
    REAL(wp), PUBLIC ::   icefeinput   !: Iron concentration in sea ice
    REAL(wp), PUBLIC ::   wdust        !: Sinking speed of the dust 
@@ -39,6 +38,4 @@
    REAL(wp)         ::   hratio       !: Fe:3He ratio assumed for vent iron supply
    REAL(wp)         ::   distcoast    !: Distance off the coast for Iron from sediments
-   REAL(wp), PUBLIC ::   fep_rats     !: Fep/Fer ratio from sed  sources
-   REAL(wp), PUBLIC ::   fep_rath     !: Fep/Fer ratio from hydro sources
    REAL(wp), PUBLIC ::   lgw_rath     !: Weak ligand ratio from hydro sources
 
@@ -228,5 +225,5 @@
         &                ln_dust, ln_solub, ln_river, ln_ndepo, ln_ironsed, ln_ironice, ln_hydrofe,    &
         &                sedfeinput, distcoast, dustsolub, icefeinput, wdust, mfrac, nitrfix, diazolight, concfediaz, &
-        &                hratio, fep_rats, fep_rath, rdustfep, lgw_rath
+        &                hratio, lgw_rath
       !!----------------------------------------------------------------------
       !
@@ -265,7 +262,4 @@
          WRITE(numout,*) '      Fe to 3He ratio assumed for vent iron supply hratio  = ', hratio
          IF( ln_ligand ) THEN
-            WRITE(numout,*) '      Fep/Fer ratio from sed sources            fep_rats   = ', fep_rats
-            WRITE(numout,*) '      Fep/Fer ratio from sed hydro sources      fep_rath   = ', fep_rath
-            WRITE(numout,*) '      Fraction of dust that is dissolvable      rdustfep   = ', rdustfep
             WRITE(numout,*) '      Weak ligand ratio from sed hydro sources  lgw_rath   = ', lgw_rath
          ENDIF
Index: /NEMO/trunk/src/TOP/PISCES/P4Z/p4zsed.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P4Z/p4zsed.F90	(revision 10415)
+++ /NEMO/trunk/src/TOP/PISCES/P4Z/p4zsed.F90	(revision 10416)
@@ -60,5 +60,4 @@
       REAL(wp) ::  ztrfer, ztrpo4s, ztrdp, zwdust, zmudia, ztemp
       REAL(wp) ::  xdiano3, xdianh4
-      REAL(wp) ::  zwssfep
       !
       CHARACTER (len=25) :: charout
@@ -68,5 +67,5 @@
       REAL(wp), DIMENSION(jpi,jpj,jpk) :: zsoufer, zlight
       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) :: ztrpo4, ztrdop, zirondep, zpdep
-      REAL(wp), ALLOCATABLE, DIMENSION(:,:  ) :: zsidep, zwsfep, zironice
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:  ) :: zsidep, zironice
       !!---------------------------------------------------------------------
       !
@@ -87,5 +86,4 @@
       ALLOCATE( ztrpo4(jpi,jpj,jpk) )
       IF( ln_p5z )    ALLOCATE( ztrdop(jpi,jpj,jpk) )
-      IF( ln_ligand ) ALLOCATE( zwsfep(jpi,jpj) )
 
       zdenit2d(:,:) = 0.e0
@@ -131,11 +129,4 @@
          ELSE
             zirondep(:,:,1) = dustsolub  * dust(:,:) * mfrac * rfact2 / e3t_n(:,:,1) / 55.85 + 3.e-10 * r1_ryyss 
-         ENDIF
-         IF ( ln_ligand ) THEN
-            IF( ln_solub ) THEN
-               tra(:,:,1,jpfep) = tra(:,:,1,jpfep) + rdustfep * (1.0 - solub(:,:)) * dust(:,:) * mfrac * rfact2 / e3t_n(:,:,1) / 55.85
-            ELSE
-               tra(:,:,1,jpfep) = tra(:,:,1,jpfep) + rdustfep * (1.0 - dustsolub) * dust(:,:) * mfrac * rfact2 / e3t_n(:,:,1) / 55.85
-            ENDIF
          ENDIF
          zsidep(:,:)   = 8.8 * 0.075 * dust(:,:) * mfrac * rfact2 / e3t_n(:,:,1) / 28.1 
@@ -216,5 +207,4 @@
             tra(:,:,:,jpfer) = tra(:,:,:,jpfer) + hydrofe(:,:,:) * rfact2
          IF( ln_ligand ) THEN
-            tra(:,:,:,jpfep) = tra(:,:,:,jpfep) + ( hydrofe(:,:,:) * fep_rath ) * rfact2
             tra(:,:,:,jplgw) = tra(:,:,:,jplgw) + ( hydrofe(:,:,:) * lgw_rath ) * rfact2
          ENDIF
@@ -235,14 +225,4 @@
       END DO
       !
-      IF( ln_ligand ) THEN
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               ikt  = mbkt(ji,jj)
-               zdep = e3t_n(ji,jj,ikt) / xstep
-               zwsfep(ji,jj)  = MIN( 0.99 * zdep, wsfep(ji,jj,ikt)  )
-            END DO
-         ENDDO
-      ENDIF
-
       IF( .NOT.lk_sed ) THEN
 !
@@ -251,5 +231,4 @@
          IF( ln_ironsed ) THEN
                             tra(:,:,:,jpfer) = tra(:,:,:,jpfer) + ironsed(:,:,:) * rfact2
-            IF( ln_ligand ) tra(:,:,:,jpfep) = tra(:,:,:,jpfep) + ( ironsed(:,:,:) * fep_rats ) * rfact2
             !
             IF( lk_iomput .AND. knt == nrdttrc .AND. iom_use( "Ironsed" ) )   &
@@ -334,15 +313,4 @@
          END DO
       END DO
-      !
-      IF( ln_ligand ) THEN
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               ikt     = mbkt(ji,jj)
-               zdep    = xstep / e3t_n(ji,jj,ikt) 
-               zwssfep = zwsfep(ji,jj) * zdep
-               tra(ji,jj,ikt,jpfep) = tra(ji,jj,ikt,jpfep) - trb(ji,jj,ikt,jpfep) * zwssfep
-            END DO
-         END DO
-      ENDIF
       !
       IF( ln_p5z ) THEN
@@ -524,5 +492,4 @@
       !
       IF( ln_p5z )    DEALLOCATE( ztrpo4, ztrdop )
-      IF( ln_ligand ) DEALLOCATE( zwsfep )
       !
       IF( ln_timing )  CALL timing_stop('p4z_sed')
Index: /NEMO/trunk/src/TOP/PISCES/P4Z/p4zsink.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P4Z/p4zsink.F90	(revision 10415)
+++ /NEMO/trunk/src/TOP/PISCES/P4Z/p4zsink.F90	(revision 10416)
@@ -35,5 +35,4 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sinkfer            !: Small BFe sinking fluxes
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sinkfer2           !: Big iron sinking fluxes
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sinkfep      !: Fep sinking fluxes
 
    INTEGER  :: ik100
@@ -126,11 +125,4 @@
       ENDIF
 
-      IF( ln_ligand ) THEN
-         wsfep (:,:,:) = wfep
-         !
-         sinkfep(:,:,:) = 0.e0
-         CALL trc_sink( kt, wsfep, sinkfep , jpfep, rfact2 )
-      ENDIF
-
      ! Total carbon export per year
      IF( iom_use( "tcexp" ) .OR. ( ln_check_mass .AND. kt == nitend .AND. knt == nrdttrc )  )  &
@@ -214,5 +206,5 @@
       !!                     ***  ROUTINE p4z_sink_alloc  ***
       !!----------------------------------------------------------------------
-      INTEGER :: ierr(3)
+      INTEGER :: ierr(2)
       !!----------------------------------------------------------------------
       !
@@ -224,8 +216,6 @@
          &      sinkfer(jpi,jpj,jpk)                                            , STAT=ierr(1) )                
          !
-      IF( ln_ligand ) ALLOCATE( sinkfep(jpi,jpj,jpk)                            , STAT=ierr(2) )  
-         
       IF( ln_p5z    ) ALLOCATE( sinkingn(jpi,jpj,jpk), sinking2n(jpi,jpj,jpk)   ,     &
-         &                      sinkingp(jpi,jpj,jpk), sinking2p(jpi,jpj,jpk)   , STAT=ierr(3) )
+         &                      sinkingp(jpi,jpj,jpk), sinking2p(jpi,jpj,jpk)   , STAT=ierr(2) )
       !
       p4z_sink_alloc = MAXVAL( ierr )
Index: /NEMO/trunk/src/TOP/PISCES/P4Z/p4zsms.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P4Z/p4zsms.F90	(revision 10415)
+++ /NEMO/trunk/src/TOP/PISCES/P4Z/p4zsms.F90	(revision 10416)
@@ -189,6 +189,5 @@
       !!
       NAMELIST/nampisbio/ nrdttrc, wsbio, xkmort, ferat3, wsbio2, wsbio2max, wsbio2scale,    &
-         &                   wfep, ldocp, ldocz, lthet,  &
-         &                   no3rat3, po4rat3
+         &                   ldocp, ldocz, lthet, no3rat3, po4rat3
          !
       NAMELIST/nampisdmp/ ln_pisdmp, nn_pisdmp
@@ -224,5 +223,4 @@
          WRITE(numout,*) '      Big particles sinking speed length scale  wsbio2scale =', wsbio2scale
          IF( ln_ligand ) THEN
-            WRITE(numout,*) '      FeP sinking speed                              wfep   =', wfep
             IF( ln_p4z ) THEN
                WRITE(numout,*) '      Phyto ligand production per unit doc           ldocp  =', ldocp
@@ -494,5 +492,4 @@
             &         +   trn(:,:,:,jpbfe) + trn(:,:,:,jpsfe)                      &
             &         + ( trn(:,:,:,jpzoo) + trn(:,:,:,jpmes) )  * ferat3    
-         IF( ln_ligand)  zwork(:,:,:) = zwork(:,:,:) + trn(:,:,:,jpfep)                
          !
          ferbudget = glob_sum( zwork(:,:,:) * cvol(:,:,:)  )  
Index: /NEMO/trunk/src/TOP/PISCES/par_pisces.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/par_pisces.F90	(revision 10415)
+++ /NEMO/trunk/src/TOP/PISCES/par_pisces.F90	(revision 10416)
@@ -56,5 +56,4 @@
    INTEGER, PUBLIC ::   jpgop     !: Big phosphorus particles Concentration
    INTEGER, PUBLIC ::   jplgw     !: Weak Ligands
-   INTEGER, PUBLIC ::   jpfep     !: Fe nanoparticle
 
    !!---------------------------------------------------------------------
Index: /NEMO/trunk/src/TOP/PISCES/sms_pisces.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/sms_pisces.F90	(revision 10415)
+++ /NEMO/trunk/src/TOP/PISCES/sms_pisces.F90	(revision 10416)
@@ -47,5 +47,4 @@
    REAL(wp) ::   xkmort            !: ???
    REAL(wp) ::   ferat3            !: ???
-   REAL(wp) ::   wfep              !: ???
    REAL(wp) ::   ldocp             !: ???
    REAL(wp) ::   ldocz             !: ???
@@ -90,7 +89,4 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   wsbio3   !: POC sinking speed 
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   wsbio4   !: GOC sinking speed
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   wsfep
-
-
 
    !!*  SMS for the organic matter
@@ -175,7 +171,6 @@
          ! 
          IF( ln_ligand ) THEN
-           ALLOCATE( plig(jpi,jpj,jpk)  , wsfep(jpi,jpj,jpk)  ,   STAT=ierr(8) )
+           ALLOCATE( plig(jpi,jpj,jpk)  ,                         STAT=ierr(8) )
          ENDIF
-         !
       ENDIF
       !
Index: /NEMO/trunk/src/TOP/PISCES/trcini_pisces.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/trcini_pisces.F90	(revision 10415)
+++ /NEMO/trunk/src/TOP/PISCES/trcini_pisces.F90	(revision 10416)
@@ -168,5 +168,4 @@
         IF( cltra == 'PFe'      )   jppfe = jn      !: Picophytoplankton Fe biomass
         IF( cltra == 'LGW'      )   jplgw = jn      !: Weak ligands
-        IF( cltra == 'LFe'      )   jpfep = jn      !: Fe nanoparticle
       END DO
 
@@ -216,5 +215,4 @@
          IF( ln_ligand) THEN
             trn(:,:,:,jplgw) = 0.6E-9
-            trn(:,:,:,jpfep) = 0. * 5.e-6
          ENDIF
          IF( ln_p5z ) THEN